' SummaryInfo.VBS V1.01 (C) yoshioka.teruo@nifty.com 2007-06-25
' SummaryInfo.VBS shows or sets Summary Information to files.
' Usage: CScript.exe SummaryInfo.VBS [/t:Title][/s:Subject][/u:Author][/c:Category][/k:Keywords][/m:Comments] files...

Option Explicit
Dim k
Dim Title
Dim Subject
Dim Author
Dim Category
Dim Keywords
Dim Comments
'Dim RevisionNumber
Dim fSum
Dim fDoc
Dim dSum
Dim dDoc

For k=0 To WScript.Arguments.Count-1
  Select Case LCase(Left(WScript.Arguments.Item(k),3))
  Case "/t:"
    Title=Mid(WScript.Arguments.Item(k),4)
    If Title="" Then dSum=2 Else fSum=2
  Case "/s:"
    Subject=Mid(WScript.Arguments.Item(k),4)
    If Subject="" Then dSum=3 Else fSum=3
  Case "/u:"
    Author=Mid(WScript.Arguments.Item(k),4)
    If Author="" Then dSum=4 Else fSum=4
  Case "/c:"
    Category=Mid(WScript.Arguments.Item(k),4)
    If Category="" Then dDoc=2 Else fDoc=2
  Case "/k:"
    Keywords=Mid(WScript.Arguments.Item(k),4)
    If Keywords="" Then dSum=5 Else fSum=5
    Keywords=Replace(Keywords,Chr(5),vbCrLf)
    Keywords=Replace(Keywords,vbTab,vbCrLf)
  Case "/m:"
    Comments=Mid(WScript.Arguments.Item(k),4)
    If Comments="" Then dSum=6 Else fSum=6
    Comments=Replace(Comments,Chr(5),vbCrLf)
    Comments=Replace(Comments,vbTab,vbCrLf)
'  Case "/r:"
'    RevisionNumber=Mid(WScript.Arguments.Item(k),4)
'    If RevisionNumber="" Then dSum=9 Else fSum=9
  Case Else
    Exit For
  End Select
Next
If k=WScript.Arguments.Count Then
  WScript.Echo "Usage: CScript.exe SummaryInfo.VBS [/t:Title][/s:Subject][/u:Author][/c:Category][/k:Keywords][/m:Comments] files..."
  WScript.Quit
End If
For k=k To WScript.Arguments.Count-1
  FileProc WScript.Arguments.Item(k)
Next

Sub FileProc(Path)
Dim fso
Dim Shell
Dim DSOFile
Dim File
Dim FolderItem
Dim ModifyDate

Set fso=CreateObject("Scripting.FileSystemObject")
Set File=fso.GetFile(Path)
Set Shell=CreateObject("Shell.Application")
Set FolderItem=Shell.NameSpace(File.ParentFolder.Path).Items().Item(File.Name)
ModifyDate=FolderItem.ModifyDate

Set DSOFile=CreateObject("DSOFile.OleDocumentProperties")
DSOFile.Open(FolderItem.Path)
If Title<>"" Then
  DSOFile.SummaryProperties.Title=Title
End If
If Subject<>"" Then
  DSOFile.SummaryProperties.Subject=Subject
End If
If Author<>"" Then
  DSOFile.SummaryProperties.Author=Author
End If
If Category<>"" Then
  DSOFile.SummaryProperties.Category=Category
End If
If Keywords<>"" Then
  DSOFile.SummaryProperties.Keywords=Keywords
End If
If Comments<>"" Then
  DSOFile.SummaryProperties.Comments=Comments
End If
'If RevisionNumber<>"" Then
'  DSOFile.SummaryProperties.RevisionNumber=RevisionNumber
'End If
DSOFile.Save
DSOFile.Close
FolderItem.ModifyDate=ModifyDate

Dim Rows
Rows=Array(FolderItem.Path)
DSOFile.Open(FolderItem.Path)
Push Rows,"Title"&vbTab&DSOFile.SummaryProperties.Title
Push Rows,"Subject"&vbTab&DSOFile.SummaryProperties.Subject
Push Rows,"Author"&vbTab&DSOFile.SummaryProperties.Author
Push Rows,"Category"&vbTab&DSOFile.SummaryProperties.Category
Keywords=DSOFile.SummaryProperties.Keywords
Keywords=Replace(Keywords,vbCrLf,vbTab)
Push Rows,"Keywords"&vbTab&Keywords
Comments=DSOFile.SummaryProperties.Comments
Comments=Replace(Comments,vbCrLf,vbTab)
Push Rows,"Comments"&vbTab&Comments
'Push Rows,"RevisionNumber"&vbTab&DSOFile.SummaryProperties.RevisionNumber
DSOFile.Close
WScript.Echo Join(Rows,vbLf)
End Sub

Sub Push(Items,Item)
ReDim Preserve Items(UBound(Items)+1)
Items(UBound(Items))=Item
End Sub
